require_relative '../helper.rb'

class ClassMethodsTest < Test::Unit::TestCase
  test '.test_class returns the class as a string' do
    assert_equal 'HappyPath', HappyPathTest.test_class
    assert_equal 'HappyPath', TestHappyPath.test_class
  end

  test '.test_class returns nil if the constant is not found' do
    assert_nil NoClassTest.test_class
  end

  test '.test_class returns nil given the class name does not start or end with Test' do
    assert_nil NoTestPrefixOrSuffix.test_class
  end

  test '.test_class returns the class given the class starts with "Tests"' do
    assert_equal 'TestsSomething', TestsSomethingTest.test_class
  end

  test '.test_class returns the class given the class starts with "Test"' do
    assert_equal 'TestPrefix', TestPrefixTest.test_class
  end

  test '.test_class returns the class given the class ends with "Test"' do
    assert_equal 'SuffixTest', TestSuffixTest.test_class
  end
end

class HappyPath
end

class HappyPathTest
  extend TestUnitHelper::ClassMethods
end

class TestHappyPath
  extend TestUnitHelper::ClassMethods
end

class NoClassTest
  extend TestUnitHelper::ClassMethods
end

class NoTestPrefixOrSuffix
  extend TestUnitHelper::ClassMethods
end

class TestsSomething
end

class TestsSomethingTest
  extend TestUnitHelper::ClassMethods
end

class TestPrefix
end

class TestPrefixTest
  extend TestUnitHelper::ClassMethods
end

class SuffixTest
end

class TestSuffixTest
  extend TestUnitHelper::ClassMethods
end


